.486
.model flat, stdcall
option casemap: none
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DialogProc PROTO:HWND,:UINT,:WPARAM,:LPARAM
DrawItem   PROTO:HWND,:LPARAM
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.const
	IDC_MSG		equ 403
	IDC_EXIT	equ 404

	CR_BACKGROUND	equ 0ff00ffh
	CR_FOREGROUND	equ 0ff00h
	CR_HIGHLIGHT	equ 0ffh

	CR_INPUT	equ 0ff0000h
	CR_INPUT2	equ 0FFffh
	szCaption	db "Color Button Demo",0
	szMsg		db "Please pay attention to 'MSG' Button on Clicking.",0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data?
	hInstance  HINSTANCE ?

	hBgColor   HBRUSH    ?
	hFgColor   HBRUSH    ?
	hInColor   HBRUSH    ?
	hIn2Color  HBRUSH    ?
	hEdge      HPEN      ?
	hEdge2     HPEN      ?
	; Font & text
	BoldFont   LOGFONT   <?>
	sBtnText   TCHAR     16 dup(?)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax

	; Create brushes for custom colors
	invoke CreateSolidBrush, CR_BACKGROUND
	mov hBgColor, eax

	invoke CreateSolidBrush, CR_INPUT
	mov hInColor, eax

	invoke CreatePen, PS_INSIDEFRAME, 2, CR_FOREGROUND
	mov hEdge, eax
	invoke CreatePen, PS_INSIDEFRAME, 2, CR_INPUT2 
	mov hEdge2, eax

	invoke DialogBoxParam, hInstance, 100, NULL, ADDR DialogProc, 0

	; Restore the memory used for graphic objects
	invoke DeleteObject, hEdge
	invoke DeleteObject, hInColor
	invoke DeleteObject, hIn2Color
	invoke DeleteObject, hFgColor
	invoke DeleteObject, hBgColor
	       
	invoke ExitProcess, 0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DialogProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg == WM_INITDIALOG
  
	.elseif uMsg == WM_CTLCOLORDLG
		mov eax, hBgColor
		ret
  
	.elseif uMsg == WM_DRAWITEM
		invoke DrawItem, hWnd, lParam
 
	.elseif uMsg == WM_COMMAND
		.if wParam ==  IDC_EXIT
			invoke SendMessage, hWnd, WM_CLOSE, 0, 0
		.elseif wParam ==  IDC_MSG
			invoke MessageBox,hWnd,addr szMsg,addr szCaption,MB_OK
		.endif
  
	.elseif uMsg == WM_CLOSE
		invoke EndDialog, hWnd, 0
	.endif
	
	xor eax, eax
	ret
DialogProc ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DrawItem PROC uses esi hWnd:HWND,lParam:LPARAM
	
	mov esi, lParam
	assume esi: ptr DRAWITEMSTRUCT

	;buttons color
	invoke SelectObject, [esi].hdc, hInColor

	;frame color
	.if [esi].itemState & ODS_SELECTED
		invoke SelectObject, [esi].hdc, hEdge2
	.else
		invoke SelectObject, [esi].hdc, hEdge
	.endif

	invoke FillRect, [esi].hdc, ADDR [esi].rcItem, hBgColor
	invoke RoundRect, [esi].hdc, [esi].rcItem.left, [esi].rcItem.top, [esi].rcItem.right, [esi].rcItem.bottom, 6, 6

	.if [esi].itemState & ODS_SELECTED
		invoke OffsetRect, ADDR [esi].rcItem, 1, 1
	.endif

	; Write the text
	invoke GetDlgItemText, hWnd, [esi].CtlID, ADDR sBtnText, SIZEOF sBtnText
	invoke SetBkMode, [esi].hdc, TRANSPARENT

	;textcolor
	.if [esi].itemState & ODS_SELECTED
		invoke SetTextColor, [esi].hdc, CR_INPUT2
	.else
		invoke SetTextColor, [esi].hdc, CR_HIGHLIGHT
	.endif

	invoke DrawText, [esi].hdc, ADDR sBtnText, -1, ADDR [esi].rcItem, DT_CENTER or DT_VCENTER or DT_SINGLELINE

	.if [esi].itemState & ODS_SELECTED
		invoke OffsetRect, ADDR [esi].rcItem, -1, -1
	.endif

	; Draw the focus rectangle
	.if [esi].itemState & ODS_FOCUS
		invoke InflateRect, ADDR [esi].rcItem, -3, -3
		;INVOKE DrawFocusRect, [esi].hdc, ADDR [esi].rcItem
	.endif
	assume esi:nothing

	mov eax, TRUE
	ret
DrawItem ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

end start